<script>
    export default {
        props: {
            id: String,
            value: [ String, Number, Object ],
            placeholder: String,
            errorMessage: String,
            type: String,
            maxlength: Number,
            regexp: RegExp,
            regexErrorText: String,
        },
        data: () => ({
            showError: false,
            regexpError: false,
            regexpTypes: {
                decimal: /^(\d{0,10}?[.]{0,1}?\d{0,10}?)$/g,
                currency: /^((\$?\-?)|(\-?\$?))([0-9]{1,3},([0-9]{3},)*[0-9]{3}|[0-9]+)?(\.[0-9]*)?$/g,
                integer: /^\d+$/g,
                letters: /^[a-zA-zÀ-ú\s]*$/g,
                email: /^[\w-\.]+@([\w-]+\.)+[\w-]{2,4}$/g
            },
        }),
        methods: {
            handleInput(e) {
                var position = Object.keys(this.regexpTypes).indexOf(this.type);
                var approveValue = true;
                let value = e.target.value.trim();

                if ( position > -1 &&  value != '' ) {
                    approveValue = !!value.trim().match( this.regexpTypes[this.type] );
                }

                if ( !approveValue ) {
                    e.target.value = !!e.target._value ? e.target._value : '';
                    return;
                }

                e.preventDefault();
                this.resetError();

                this.$emit('input', value);
                return;
            },
            filterRegexp(e) {
                let char = e.target.value;

                if ( char.trim() != '' ) {
                    this.regexpError = !!!char.match(this.regexp);
                }

                if(char.match(this.regexp)) {
                    return true;
                }

                e.preventDefault();
            },
            resetError() {
                this.showError = false;
                this.regexpError = false;
            },
        },
        computed: {
            errors(){
                if (this.showError || this.regexpError) {
                    return 'is-invalid'
                }
            }
        }
    }
</script>

<template>
    <div>
        <input
            class="form-input"
            :class="errors"
            :id="id"
            :name="id"
            :value="value"
            :type="type"
            :maxlength="!!maxlength ? maxlength : 255"
            :placeholder="placeholder ? placeholder : ''"
            @input="handleInput"
            @blur="filterRegexp($event)"
            @keyup.enter="$emit('enter')"
        >
        <div class="invalid-feedback" v-if="showError"> {{ errorMessage }} </div>
        <div class="invalid-feedback" v-if="!showError && regexpError"> {{ regexErrorText }} </div>
    </div>
</template>